#ifndef __PVS_H
#define __PVS_H

#include <map>

class KdNode;
class BspNode;
class Ray;
class Intersectable;


template<typename T>
struct LtSample {
    bool operator()(const T *a, const T *b) const
    {
		return a < b;
	} 
};

//typedef std::map<T *, PvsData<T>, LtSample<T>> PvsMap<T>;

template<typename T> 
struct PvsData {
  int mVisibleSamples;
  PvsData<T>() {}
  PvsData<T>(const int samples):mVisibleSamples(samples) {}
};

template<typename T>
class mypvs 
{
public:
    mypvs(): mSamples(0), mEntries() {}
	int mSamples;

	//int Compress() {return 0;}
	int GetSize() {return (int)mEntries.size();}

	PvsData<T> *Find(T sample);
	int AddSample(T sample);

	void GetData(const int index,
	       T &entry,
	       PvsData<T> &data);
	std::map<T, PvsData<T>, LtSample<T> > mEntries;
};


template <typename T>
PvsData<T> *mypvs<T>::Find(T sample)
{
  /*std::map<T *, PvsData<T>, LtSample<T> >::iterator i = mEntries.find(sample);
  if (i != mEntries.end()) {
    return &(*i).second;
  } else*/
    return NULL;
}

template <typename T>
void mypvs<T>::GetData(const int index,
	       T &entry,
	       PvsData<T> &data)
{
  /*PvsMap<typename T>::iterator i = mEntries.begin();
  for (int k = 0; k != index && i != mEntries.end(); i++, k++);

  entry = (*i).first;
  data = (*i).second;*/
}

struct LtKdNode
{
  bool operator()(const KdNode *a,
		  const KdNode *b) const
  {
    return a < b;
  }
  
};

/** Superclass for all types of PVS data.
*/
class Pvs {
public:
	Pvs(): mSamples(0) {}
	int mSamples;

	virtual int Compress() = 0;
	virtual int GetSize() = 0;
};

struct KdPvsData {
  int mVisibleSamples;
  KdPvsData() {}
  KdPvsData(const int samples):mVisibleSamples(samples) {}
};

typedef std::map<KdNode *, KdPvsData, LtKdNode> KdPvsMap;


class KdPvs: public Pvs {
public:
 
  KdPvsMap mEntries;
  
  KdPvs():mEntries() {}
  
  KdPvsData *Find(KdNode *node);
  int AddNodeSample(KdNode *node);
  int Compress() {return 0;}
  int GetSize() { return (int)mEntries.size(); }
  void GetData(const int index,
	       KdNode *&node,
	       KdPvsData &data
	       );
  
};

struct LtBspNode
{
  bool operator()(const BspNode *a,
		  const BspNode *b) const
  {
	  return a < b;
  }
};

struct BspPvsData {
  int mVisibleSamples;
  BspPvsData() {}
  BspPvsData(const int samples): mVisibleSamples(samples) {}
};

typedef std::map<BspNode *, BspPvsData, LtBspNode> BspPvsMap;

class BspPvs: public Pvs 
{
public:
	BspPvs(): mEntries() {}

	BspPvsMap mEntries;
 
	BspPvsData *Find(BspNode *node);
	int AddNodeSample(BspNode *node);
	
	int Compress() {return 0;}
	
	int GetSize() {return (int)mEntries.size();}
	
	void GetData(const int index,
				 BspNode *&node,
				 BspPvsData &data);
};


struct LtIntersectable
{
  bool operator()(const Intersectable *a,
		  const Intersectable *b) const
  {
	  return a < b;
  }
};

struct ViewCellPvsData {
  int mVisibleSamples;
  ViewCellPvsData() {}
  ViewCellPvsData(const int samples): mVisibleSamples(samples) {}
};

typedef std::map<Intersectable *, ViewCellPvsData, LtIntersectable> ViewCellPvsMap;

class ViewCellPvs 
{
public:
	ViewCellPvs(): mEntries() {}

	ViewCellPvsMap mEntries;
 
	int Compress() {return 0;}
	int GetSize() {return (int)mEntries.size();}

	ViewCellPvsData *Find(Intersectable *obj);
	int AddObject(Intersectable *obj);

	void GetData(const int index, 
				 Intersectable *&obj,
				 ViewCellPvsData &data);

};

#endif

